
#include "stdafx.h"

#include "resource.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "transform.h"
#include "process.h"

#include "wos.h"
#include "err.h"
#include "task.h"
#include "poll.h"
#include "temp.h"
#include "scrap.h"
#include "fsx.h"
#include "conf.h"
#include "etc.h"
#include "flex.h"
#include "sp.h"
#include "deb.h"
#include "appinfo.h"
#include "mlo.h"
#include "osunits.h"
#include "colour.h"
#include "save.h"
#include "load.h"
#include "wmf.h"
#include "osunits.h"
#include "imlib.h"
#include "bmpim.h"
#include "pane.h"
#include "bits.h"
#include "xmath.h"


#include "constants.h"


#include "veclib.h"
#include "main.h"
#include "file.h"
#include "reslink.h"
#include "fit.h"


int spddx;
int spddy;
int spdx;
int spdy;
int spx;
int spy;
int sposx;
int sposy;
int zoommul=1;
int zoomdiv=1;



int paltab[256];


vechandle vhandle;


framebasestr * framebase;



/*************************************************************************************/

static imageinfohandle;



static os_error * imageinfoicon(int handle,int userhandle,wimp_mousestr * m);
static os_error * imageinfokey(int handle,int userhandle,int icon,int * key);

static os_error * imageinfoclose(int w,int userhandle)
{
 os_error * err;


 remclickevent(imageinfoicon,imageinfohandle,0);
 remcloseevent(imageinfoclose,imageinfohandle,0);
 remkeyevent(imageinfokey,imageinfohandle,0);

 err=closedown(&imageinfohandle);

 return(err);

 USE(userhandle);
 USE(w);
}



static os_error * imageinfoicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
               case     IDOK:
                             err=imageinfoclose(handle,userhandle);
                             break;

 }

 return(err);
}



static os_error * imageinfokey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;

 err=NULL;


 if(*key==27)
 {
  err=imageinfoclose(handle,userhandle);
  *key=-1;
 }

 return(err);
 USE(icon);
}






os_error * imageinfowindow(int parent)
{
 os_error * err;
 int        bpp;

 if(imageinfohandle) err=forward(imageinfohandle,0,NULL);
 else
 {
  err=createwindowparent(TIMAGEINFO,&imageinfohandle,parent);


  if(!err)
  {
   if(framebase)
   {
    writeiconf(imageinfohandle,ID_IMAGEINFO_SIZE,"X %d Y %d",spx,spy);
    writeicon(imageinfohandle,ID_IMAGEINFO_MEMORY,memstring(framebase->frame[0].im[0].wwidth*spy));
    writeiconf(imageinfohandle,ID_IMAGEINFO_RESOLUTION,"X %d Y %d",framebase->frame[0].im[0].xdpi,framebase->frame[0].im[0].ydpi);
    bpp=framebase->frame[0].im[0].bpp;
    if(bpp<=8) writeiconf(imageinfohandle,ID_IMAGEINFO_COLOURS,"%d",(1<<bpp));
    else
    {
     if(bpp==16) writeiconf(imageinfohandle,ID_IMAGEINFO_COLOURS,"{K32}");
     else        writeiconf(imageinfohandle,ID_IMAGEINFO_COLOURS,"{M16}");
    }
   }
   else
   {
    writeiconf(imageinfohandle,ID_IMAGEINFO_SIZE,"-");
    writeiconf(imageinfohandle,ID_IMAGEINFO_MEMORY,"-");
    writeiconf(imageinfohandle,ID_IMAGEINFO_RESOLUTION,"-");
    writeiconf(imageinfohandle,ID_IMAGEINFO_COLOURS,"-");
   }

   if(vhandle)
   {
    writeicon(imageinfohandle,ID_IMAGEINFO_VMEMORY,memstring(vecsize(vhandle)));

   }
   else
   {
    writeiconf(imageinfohandle,ID_IMAGEINFO_VMEMORY,"-");
   }

   addclickevent(imageinfoicon,imageinfohandle,0);
   addcloseevent(imageinfoclose,imageinfohandle,0);
   addkeyevent(imageinfokey,imageinfohandle,0);

   popup(imageinfohandle,0);

   iecarrot(imageinfohandle,IDOK);
  }
 }

 return(err);
}


/***********************************************************************************/


static zoomhandle;



static os_error * zoomicon(int handle,int userhandle,wimp_mousestr * m);
static os_error * zoomkey(int handle,int userhandle,int icon,int * key);

static os_error * zoomclose(int w,int userhandle)
{
 os_error * err;


 remclickevent(zoomicon,zoomhandle,0);
 remcloseevent(zoomclose,zoomhandle,0);
 remkeyevent(zoomkey,zoomhandle,0);
 enablewindow(mainhandle,1,0);
 err=closedown(&zoomhandle);

 return(err);

 USE(userhandle);
 USE(w);
}



static os_error * setzoomextent(int mul,int div)
{

 zoommul=mul;
 zoomdiv=div;

 extent(vectorhandle,0,-scale(sposy,zoommul,zoomdiv),scale(sposx,zoommul,zoomdiv),0);
 extent(bitmaphandle,0,-scale(sposy,zoommul,zoomdiv),scale(sposx,zoommul,zoomdiv),0);
 refreshwindow(vectorhandle);
 refreshwindow(bitmaphandle);

 return(NULL);
}


static os_error * writezoom(void)
{
 return(writeiconf(zoomhandle,IDC_ZOOM_CUSTOM,"%d%%",(100*zoommul)/zoomdiv));
}


static os_error * setzoom(int mul,int div)
{

 setzoomextent(mul,div);
 writezoom();
 return(NULL);
}



static os_error * zoomfit(void)
{
 os_error * err;
 windowstr  window;
 int        vsize;
 int        bsize;

 err=NULL;

 if(framebase)
 {
  if(sposx>sposy)
  {
   geto(vectorhandle,&window);
   vsize=window.x1-window.x0;
   geto(bitmaphandle,&window);
   bsize=window.x1-window.x0;
   if(vsize<bsize) err=setzoom(vsize,sposx);
   else            err=setzoom(bsize,sposx);
  }
  else
  {
   geto(vectorhandle,&window);
   vsize=window.y1-window.y0;
   geto(bitmaphandle,&window);
   bsize=window.y1-window.y0;
   if(vsize<bsize) err=setzoom(vsize,sposy);
   else            err=setzoom(bsize,sposy);
  }
 }
 return(err);
}



static os_error * zoomkey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;
 char       string[256];
 int        zoom;

 err=NULL;


 if(*key==27)
 {
  err=zoomclose(handle,userhandle);
  *key=-1;
 }
 else
 if(*key==13)
 {
  readicon(handle,IDC_ZOOM_CUSTOM,string,sizeof(string));

  if(sscanf(string,"%d",&zoom)==1)
  {
   if(zoom<10)   zoom=10;
   if(zoom>1000) zoom=1000;
   setzoom(zoom,100);
  }

  *key=-1;
 }

 return(err);
 USE(icon);
}




static os_error * zoomicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        key;


 err=NULL;

 switch(m->i)
 {

               case IDC_ZOOM_10:
                                err=setzoom(1,10);
                                break;

               case IDC_ZOOM_20:
                                err=setzoom(1,5);
                                break;

               case IDC_ZOOM_50:
                                err=setzoom(1,2);
                                break;

              case IDC_ZOOM_100:
                                err=setzoom(1,1);
                                break;

              case IDC_ZOOM_200:
                                err=setzoom(2,1);
                                break;

              case IDC_ZOOM_400:
                                err=setzoom(4,1);
                                break;

              case IDC_ZOOM_FIT:
                                err=zoomfit();
                                break;


              case    IDCANCEL:
                               key=27;
                               err=zoomkey(handle,userhandle,m->i,&key);
                               break;


              case    IDOK:
                               key=13;
                               err=zoomkey(handle,userhandle,m->i,&key);
                               break;
 }

 return(err);
 USE(userhandle);
 USE(handle);
}








os_error * zoombox(int parent)
{
 os_error * err;

 if(zoomhandle) err=forward(zoomhandle,0,NULL);
 else
 {
  err=createwindowparent(TZOOM,&zoomhandle,parent);


  if(!err)
  {

   addclickevent(zoomicon,zoomhandle,0);
   addcloseevent(zoomclose,zoomhandle,0);
   addkeyevent(zoomkey,zoomhandle,0);
   writezoom();
   popup(zoomhandle,0);
   iecarrot(zoomhandle,IDC_ZOOM_CUSTOM);
   enablewindow(mainhandle,0,0);
  }
 }

 return(err);
}

/*********************************************************************************/



static settingshandle;



static os_error * settingsicon(int handle,int userhandle,wimp_mousestr * m);
static os_error * settingskey(int handle,int userhandle,int icon,int * key);


static os_error * settingsclose(int w,int userhandle)
{
 os_error * err;


 remclickevent(settingsicon,settingshandle,0);
 remcloseevent(settingsclose,settingshandle,0);
 remkeyevent(settingskey,settingshandle,0);
 remhelpevent(NULL,settingshandle,TSETTINGS);

 enablewindow(mainhandle,1,0);

 err=closedown(&settingshandle);

 return(err);

 USE(userhandle);
 USE(w);
}




static os_error * writeerror(void)
{
 return(writeiconf(settingshandle,IDC_SETTINGS_ERROR,"%2.2f",pixerror));
}



static os_error * settingsicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 char       string[256];
 float      errorvalue;

 err=NULL;

 switch(m->i)
 {
  case IDOK:
  case IDCANCEL:
                readicon(handle,IDC_SETTINGS_ERROR,string,sizeof(string));

                if(sscanf(string,"%f",&errorvalue)==1)
                {
                 if(errorvalue<0.001)  errorvalue=(float)0.001;
                 if(errorvalue>10.0)   errorvalue=10.0;
                 pixerror=(double)errorvalue;
                }

                err=settingsclose(handle,userhandle);
                break;

 
 }

 return(err);
 USE(userhandle);
 USE(handle);
}



static os_error * settingskey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;

 err=NULL;


 if(*key==27)
 {
  err=settingsclose(handle,userhandle);
  *key=-1;
 }
 else
 if(*key==13)
 {

  
  *key=-1;
 }

 return(err);
 USE(icon);
}






os_error * settings(int parent)
{
 os_error * err;

 if(settingshandle) err=forward(settingshandle,0,NULL);
 else
 {
  err=createwindowparent(TSETTINGS,&settingshandle,parent);


  if(!err)
  {
   addclickevent(settingsicon,settingshandle,0);
   addcloseevent(settingsclose,settingshandle,0);
   addkeyevent(settingskey,settingshandle,0);
   addhelpevent(NULL,settingshandle,TSETTINGS);
   writeerror();
   popup(settingshandle,0);
   iecarrot(settingshandle,IDC_SETTINGS_ERROR);
   enablewindow(mainhandle,0,0);
  }
 }

 return(err);
}






/*********************************************************************************/

int pixelxy(int x,int y)
{
 y=(spy-1)-y;
 return(impixelxy(x,y,&framebase->frame[0].im[0]));
}



os_error *loadbitmaptypev(char * name,int type,mousestr * m,int userhandle,int * method)
{
 if(type==BMP)                          *method=1;
 else                                   *method=0;

 return(NULL);
 USE(userhandle);
 USE(m);
 USE(name);
}



os_error * loadbitmapv(char * name,int type,int userhandle,int xvolatile)
{
 os_error  * err;
 int         i;

 err=imscrapframebase(&framebase);
 if(!err)
 {
  err=imnewframebase(&framebase);
  if(!err)
  {
   err=loadbmp(name,&framebase);
   if(!err)
   {
    spx=framebase->frame[0].im[0].xpix;
    spy=framebase->frame[0].im[0].ypix;
    spdx=1;
    spdy=1;
    spddx=256;
    spddy=256;

    if(framebase->frame[0].im[0].xdpi==0) sposx=(spx*OSXRES)/cvdu.xdpi;
    else                                  sposx=(spx*OSXRES)/framebase->frame[0].im[0].xdpi;

    if(framebase->frame[0].im[0].ydpi==0) sposy=(spy*OSYRES)/cvdu.ydpi;
    else                                  sposy=(spy*OSYRES)/framebase->frame[0].im[0].ydpi;


    vecscrap(&vhandle);
    setzoomextent(1,1);

    for(i=0;i<framebase->frame[0].im[0].ipal.ncolours;i++)
    {
     paltab[i]=PALFROMQUAD(framebase->frame[0].im[0].ipal.word[i]);
    }
   }
  }
 }

 return(err);
 USE(userhandle);
 USE(type);
 USE(xvolatile);
}



os_error * loadbitmappostv(int userhandle)
{
 os_error    * err;

/* dprintf(0,"load doc post"); */

 err=NULL;


 return(err);

 USE(userhandle);
}








static os_error * fload(char * name,int type,int userhandle,int xvolatile)
{
 os_error * err;

          err=loadbitmapv(name,type,0,0);
 if(!err) err=loadbitmappostv(0);

 return(err);

 USE(userhandle);
 USE(xvolatile);
}




os_error * loadbitmap(int handle)
{
 os_error * err;
 loadoptstr opts;
 int        xtype=BMP;
 int        copt;
 char       name[MAX_PATH];

 opts.description="Bitmap files (*.bmp)";
 opts.ntypes=1;
 opts.types=&xtype;

 strcpy(name,"");

 err=openloadparent(name,&copt,&opts,1,fload,0,handle);

 return(err);
}





static os_error * csaveoption(int handle,int opt,int * type,char * name,int maxlen)
{
 switch(opt)
 {

  case 0:
         *type=EMFTYPE;
         break;

  case 1:
         *type=PMFTYPE;
         break;

  case 2:
         *type=EMFTYPE;
         break;
 }


 return(NULL);
 USE(handle);
 USE(name);
}




static saveoptionstr saveoptions[]=
{
 TEXT("Enhanced metafile (*.emf)"),    csaveoption,

};




static int csaveopt;







static os_error * saveasemf(char * name)
{
 os_error * err;
 metahandle handle;
 char       desc[64];
 int        maxx;
 int        maxy;

 maxx=sposx;
 maxy=sposy;

 sprintf(desc,"Trace\0%d\0",0);

 err=openemf(name,0,maxx,maxy,&handle,desc);
 if(!err)
 {
  vecpaint(0,maxy,maxx,-maxy,vhandle,0);
  err=closeemf(err,handle);
 }

 return(err);
}





static os_error * csavefile(char * name,int type)
{
 os_error * err;

 err=NULL;

 switch(type)
 {


   case EMFTYPE:
                err=saveasemf(name);
                break;
 }

 return(err);
}




os_error * savevector(int handle)
{
 os_error * err;
 char       savepath[MAX_PATH];

 if(!vhandle) err=geterror(ENOVECTOR);
 else
 {
  setsaveoptions(1,saveoptions,&csaveopt);
  *savepath=0;
  strcpy(savepath,"tracing");
  err=opensaveparent(savepath,NITEM(savepath),WMFTYPE,csavefile,handle);
 }

 return(err);
}


